/*++
Module Name:
	westpak.h

Version:
	1.9.4.104
--*/

#ifndef __WESTPAK_H
#define __WESTPAK_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stddef.h>

#define ALGO_NO		0
#define ALGO_LZSS	1
#define ALGO_DIR	2
#define ALGO_LZSS_XOR	3

typedef struct {
	unsigned int Type;
	size_t Offset;
	size_t CompressedSize;
	size_t Size;
	wchar_t FileName[MAX_PATH];
} ENUMPAKFILEW;
typedef struct {
	unsigned int Type;
	size_t Offset;
	size_t CompressedSize;
	size_t Size;
	char FileName[MAX_PATH];
} ENUMPAKFILEA;
typedef int (API ENUMPAKPROCW)(const wchar_t *, const ENUMPAKFILEW *, void *);
typedef int (API ENUMPAKPROCA)(const char *, const ENUMPAKFILEA *, void *);

// westpak & westpak1 exports
size_t __stdcall lzssdecompress(const char *InBuf, size_t InLen, char *OutBuf, size_t OutLen);
size_t __stdcall lzssdecompress_xor(const char *InBuf, size_t InLen, char *OutBuf, size_t OutLen);
int __stdcall decodepakfile(const char *filename);
int __stdcall decodepakfileW(const wchar_t *filename);
size_t __stdcall GetFileFromPak(char *buf, size_t buflen, const wchar_t *fn_unicode, const char *fnwant_gb18030);
size_t __stdcall GetFileFromPakA(char *buf, size_t buflen, const char *fn_ansi, const char *fnwant_ansi);
size_t __stdcall GetFileFromPakW(char *buf, size_t buflen, const wchar_t *fn_unicode, const wchar_t *fnwant_unicode);
#define GetFileFromPakOffsetA GetFileFromPakOffset2A
#define GetFileFromPakOffsetW GetFileFromPakOffset2W
size_t __stdcall GetFileFromPakOffset2A(char *buf, size_t buflen, const char *fnpak, size_t offset, size_t compsize, int algo);
size_t __stdcall GetFileFromPakOffset2W(char *buf, size_t buflen, const wchar_t *fnpak, size_t offset, size_t compsize, int algo);
#define EnumFileFromPakA EnumFileFromPak2A
#define EnumFileFromPakW EnumFileFromPak2W
int __stdcall EnumFileFromPak2A(const char *PakName, ENUMPAKPROCA lpEnumFunc, void *param);
int __stdcall EnumFileFromPak2W(const wchar_t *PakName, ENUMPAKPROCW lpEnumFunc, void *param);

// westpak exports
size_t __stdcall lzsscompress(const char *InBuf, size_t InLen, char *OutBuf, size_t *pOutLen);
size_t __stdcall lzsscompress2(const char *InBuf, size_t InLen, char *OutBuf, size_t *pOutLen, int CompressLevel);
size_t __stdcall lzsscompress_xor(const char *InBuf, size_t InLen, char *OutBuf, size_t *pOutLen);
size_t __stdcall lzsscompress2_xor(const char *InBuf, size_t InLen, char *OutBuf, size_t *pOutLen, int CompressLevel);
size_t __stdcall lzsscompressbound(size_t DataLength);
int __stdcall encodepakfile(const char *dirname);
int __stdcall encodepakfileW(const wchar_t *dirname);
int __stdcall encodepakfile2A(const char *dirname, const int CompressLevel);
int __stdcall encodepakfile2W(const wchar_t *dirname, const int CompressLevel);
int __stdcall setcopyrightinfo(const char *name);

#ifdef __cplusplus
}
#endif

#endif
